
#define VERSION "@(#)MD50NA 0.3 970410 PROM"

/*
 *  0.0 970401 First cut
 *  0.1 970404 2nd.
 *  0.2 070409 TX added.
 *  0.3 070410 TX power level fixed.
 *             Removed NMIC from 1750 kludge.
 *
 *  Juha, OH5NXO
 */

Rint = 1
Rstk = 2
Rpgm = 3
Rcal = 4	# SCRT "call"
Rret = 5	# SCRT "return"
Rarg = 6	# SCRT "temporary & arguments"
Rbp  = 7	# Extended SCRT, for stack frame

Rtmp = 8
Rtbl = 0xD	# Always to tables
Rram = 0xA
Rptr = 0xB
Rtmp2 = 0xC

HLT = 1
MDM = 2
REG = 4

/* Modem status register */

MDMSQ  = 0x80
MDMINT = 0x40	# Maybe...

#define shr4 shr; shr; shr; shr
#define shl4 shl; shl; shl; shl

#define LDREG(r,a)  ldi LO(a) ; plo r ; ldi HI(a) ; phi r
#define ADJUST(r,a) ldi LO(a) ; plo r

#define CALL(f) sep Rcal ; .byte LO(f), HI(f)
#define RETURN  sep Rret

#define BYTE   : .rs 1
#define BUF(n) : .rs n

#define SET(a,bits) ADJUST(Rram,a); ldn Rram ; ori  (bits) ; str Rram ; sex Rram ; out REG ; dec Rram
#define CLR(a,bits) ADJUST(Rram,a); ldn Rram ; ani ~(bits) ; str Rram ; sex Rram ; out REG ; dec Rram
#define FLIP(a,bits) ADJUST(Rram,a); ldn Rram ; xri (bits) ; str Rram ; sex Rram ; out REG ; dec Rram

#define PULSE(a,bits) SET(a,bits); CLR(a,bits)

#define LIT(BIT) ADJUST(Rram, indicators); ldn Rram; ori  MASK(BIT); str Rram
#define DIM(BIT) ADJUST(Rram, indicators); ldn Rram; ani ~MASK(BIT); str Rram

/*	CU53 LATCH bits */

#define BIT_AVAIL    0	/* not connected */
#define BIT_CALL     1
#define BIT_SERV     2
#define BIT_KEYLIGHT 3
#define BIT_ROAM     4
#define BIT_HF       5
#define BIT_LCDLIGHT 6
#define BIT_BRIGHT   7

#define MASK(bit) (1 << (bit))

#define X(seg) (seg)

/*	CU53 Special LCD segments */

#define SEG_KEY      (127)
#define SEG_T        (123)
#define SEG_C        ( 67)
#define SEG_COLON_L  (103)
#define SEG_COLON_R  ( 71)
#define SEG_BAR_L    ( 79)
#define SEG_BAR_R    ( 91)
#define SEG_S        (115)
#define SEG_F        (119)
#define SEG_D        ( 75)
#define SEG_I        ( 83)
#define SEG_LESS     ( 87)
#define SEG_N        ( 95)

#undef X

	.data
	.org 0x8000

ram:

outputs:			# Address bits 3..1 special !

sereg:
volareg:
output_0:	.rs 2	# every another byte padding

SE     = 1

audioreg:
txbreg:
output_1:	.rs 2

TXB    = 1
AUDIO  = 2
NPHI   = 4
NMIC   = 8

csreg:
txareg:
output_2:	.rs 2

TXA    = 1
CSMSK  = 0xE
KEYPAD = 0
LATCH  = 2
LCD1   = 4
LCD2   = 6

#define CUSEL(x) ADJUST(Rram,csreg); ldn Rram ; ani ~CSMSK ; ori x ; str Rram ; sex Rram ; out REG ; dec Rram

hfreg:
nrcreg:
output_3:	.rs 2

VCS    = 1
NRC    = 2
AT1    = 4
HF     = 8

cureg:
offreg:
output_4:	.rs 2

OFF1   = 1
DP     = 2
CLK    = 4
EXA    = 8

wdrreg:
bellreg:
output_5:	.rs 2

WDR    = 1
KV     = 2
ALO    = 4
CRM    = 8

swereg:
pscreg:
output_6:	.rs 2

SWE    = 1
PSC    = 8

xmreg:
output_7:	.rs 2

XM     = 1
AT2    = 4

channel		BYTE
volume		BYTE

memory		BYTE
txpower		BYTE
rptr		BYTE

_bss:

segments	BUF(16)		# 32 bits 4 times
indicators	BYTE		# trails segments !

lighttimer	BUF(2)

keycode		BYTE
key			BYTE

digidx		BYTE
digbuf		BUF(4)

_end:

STACK = 0x83FF

	.text
	.org 0

	dis
	.byte 0x00

	req

	LDREG(Rpgm, 1f)

	sep Rpgm
1:
	LDREG(Rint, int)
	LDREG(Rstk, STACK)
	LDREG(Rbp,  STACK)
	LDREG(Rcal, calsub)
	LDREG(Rret, retsub)
	LDREG(Rram, ram)
	LDREG(Rptr, ram)
	LDREG(Rtbl, tables)

	sex Rram

	ADJUST(Rram, outputs)

#define X(bits) ldi (bits) ; str Rram ; out REG ; inc Rram

	X(0)				# 0: vola  SE
	X(NPHI | NMIC)		# 1: NMIC NPHI AUDIO TXB
	X(LCD1)				# 2: CS3  CS2  CS1   TXA
	X(NRC)				# 3: HF   AT1  NRC   VCS
	X(0)				# 4: EXA  CLK  DP    OFF1
	X(KV)				# 5: CRM  ALO  KV    WDR
	X(0)				# 6: PSC  NPPC A7    SWE
	X(0)				# 7: A6   AT2  A4    XM

#undef X

	sex Rpgm
	ret
	.byte Rpgm


	FLIP(wdrreg, WDR)

	SET(bellreg, ALO)

	LDREG(Rtmp, 0)
1:
	dec Rtmp
	glo Rtmp
	bnz 1b
	FLIP(wdrreg, WDR)

	CLR(bellreg, ALO)
	FLIP(wdrreg, WDR)

	ADJUST(Rram, _bss)
1:
	ldi 0
	str Rram
	inc Rram
	glo Rram
	smi LO(_end)
	bnz 1b

	LDREG(Rram, ram)

	FLIP(wdrreg, WDR)

	/*CALL(marker_on), SEG_C*/

	ADJUST(Rram, indicators)
	ldi MASK(BIT_AVAIL) | MASK(BIT_LCDLIGHT) | MASK(BIT_KEYLIGHT)
	str Rram

	ADJUST(Rram, lighttimer + 1)
	ldi 1
	str Rram

	CALL(zerobuf)
	CALL(dovola), 0
	CALL(synth), 0
	CALL(dopower)
	CALL(dorptr)
	CALL(display)

	lbr top

dorptr:
	FLIP(wdrreg, WDR)

	ADJUST(Rram, rptr)
	ldn Rram
	lbz 1f
	CALL(marker_off), SEG_S
	CALL(marker_on), SEG_D
	lbr 2f
1:
	CALL(marker_on), SEG_S
	CALL(marker_off), SEG_D
2:
	RETURN

dovola:
	ADJUST(Rram, volume)
	lda Rarg
	sex Rram
	add
	smi -1
	lsnz ; ldi 1
	adi -1
	smi 10
	lsnf ; ldi -1
	adi 10
	str Rram

	phi Rtmp
	smi 2
	plo Rtmp
	lbdf 1f
	ldi 0
	plo Rtmp
1:
	ADJUST(Rram, volareg)
	glo Rtmp
	ani 7
	shl
	str Rram
	sex Rram
	out REG

	LDREG(Rtmp2, segs_u_digit_5)
	ghi Rtmp
	adi '0'
	dec Rstk
	str Rstk
	CALL(drawchr)
	inc Rstk

	RETURN

	.align 8

1:
	sep Rpgm
calsub:
	glo Rbp
	dec Rstk
	str Rstk

	glo Rstk
	plo Rbp
	inc Rbp

	ghi Rarg
	dec Rstk
	str Rstk
	glo Rarg
	dec Rstk
	str Rstk

	ghi Rpgm
	phi Rarg
	glo Rpgm
	plo Rarg

	lda Rarg
	plo Rpgm
	lda Rarg
	phi Rpgm

	br 1b

1:
	sep Rpgm
retsub:
	ghi Rarg
	phi Rpgm
	glo Rarg
	plo Rpgm

	lda Rstk
	plo Rarg
	lda Rstk
	phi Rarg

	lda Rstk
	plo Rbp

	br 1b

top:
	FLIP(wdrreg, WDR)

	CALL(chkmdm)

	/*idl*/

	PULSE(pscreg, PSC)

	b3 1f
	CALL(keypad)
	CALL(dokey)
	CALL(display)
	CALL(waitkey)
	br top
1:
	seq
	req
	b3 1f
	CALL(shutdown)
1:
	ADJUST(Rram, lighttimer)
	ldn Rram
	smi 1
	str Rram
	bnz 1f
	inc Rram
	ldn Rram
	smi 1
	str Rram
	bnz 1f
	ldi 1
	str Rram
	FLIP(wdrreg, WDR)
	DIM(BIT_LCDLIGHT)
	DIM(BIT_KEYLIGHT)
	CALL(display)
1:
	br top

chkmdm:

	FLIP(wdrreg, WDR)

	dec Rstk
	sex Rstk
	inp MDM			; ASSERT((STACK & 0x20) != 0)

	ldn Rstk
	ani ~MDMINT
	str Rstk
	ani MDMSQ
	bz 1f
	SET(audioreg, AUDIO)
	SET(hfreg, HF)
	LIT(BIT_SERV)
	br 2f
1:
	CLR(audioreg, AUDIO)
	CLR(hfreg, HF)
	DIM(BIT_SERV)
2:
	FLIP(wdrreg, WDR)

	LDREG(Rtmp2, segs_u_digit_0)
	CALL(drawbyte)
	inc Rstk

	CALL(display)

	RETURN

txon:
	FLIP(wdrreg, WDR)

	CLR(volareg, 0xE)

	ADJUST(Rram, rptr)
	ldn Rram
	lbz 1f
	CALL(synth), -64
1:
	CLR(nrcreg, NRC)
	SET(nrcreg, AT1)
	SET(xmreg, AT2)

	CLR(audioreg, NMIC)
	CLR(txareg, TXA)
	CLR(txbreg, TXB)

	SET(xmreg, XM)

	ADJUST(Rram, txpower)
	ldn Rram
	ani 1
	bz 1f
	SET(txbreg, TXB)
1:
	ADJUST(Rram, txpower)
	ldn Rram
	ani 2
	bz 1f
	SET(txareg, TXA)
1:
	LIT(BIT_ROAM)
	DIM(BIT_SERV)
	CALL(display)
	RETURN

txoff:
	FLIP(wdrreg, WDR)

	CLR(xmreg, XM)
	CLR(txareg, TXA)
	CLR(txbreg, TXB)

	SET(audioreg, NMIC | NPHI)

	DIM(BIT_ROAM)
	CALL(display)

	SET(nrcreg, NRC)
	CLR(nrcreg, AT1)
	CLR(xmreg, AT2)

	ADJUST(Rram, rptr)
	ldn Rram
	lbz 1f
	CALL(synth), 64
1:
	CALL(dovola), 0

	RETURN

synth:

	FLIP(wdrreg, WDR)

	ADJUST(Rram, channel)
	lda Rarg
	sex Rram
	add
	str Rram
	plo Rtmp2
	ldi 0
	phi Rtmp2

	glo Rtmp2
	shl
	plo Rtmp2
	ghi Rtmp2
	shlc
	phi Rtmp2
	glo Rtmp2
	shl
	plo Rtmp2
	ghi Rtmp2
	shlc
	adi HI(channels)
	phi Rtmp2

	ADJUST(Rram, swereg)

	dec Rstk		# scratch to "write" to

	sex Rpgm
	dis
	.byte Rpgm

	sex Rram

	lda Rram
	str Rram
	dec Rram
	ori SWE
	str Rram
	out REG

	ldi 0xC0		# SW1 SW2 N9 N8 - - - -
	xri 0xFF

	str Rstk; shl; str Rstk; shl	# SW1 SW2
	str Rstk; shl; str Rstk; shl	# N9  N8

	lda Rtmp2
	xri 0xFF

	str Rstk; shl; str Rstk; shl	# N7 N6
	str Rstk; shl; str Rstk; shl	# N5 N4

	str Rstk; shl; str Rstk; shl	# N3 N2
	str Rstk; shl; str Rstk; shl	# N1 N0

	lda Rtmp2
	xri 0xFF

	          shl; str Rstk; shl	#    A6
	str Rstk; shl; str Rstk; shl	# A5 A4

	str Rstk; shl; str Rstk; shl	# A3 A2
	str Rstk; shl; str Rstk; shl	# A1 A0

	out REG
	dec Rram
	ldn Rram
	dec Rram
	str Rram

	sex Rpgm
	ret
	.byte Rpgm

	PULSE(sereg, SE)

	inc Rstk

	ldi 0x43
	dec Rstk
	str Rstk

	lda Rtmp2
	dec Rstk
	str Rstk

	lda Rtmp2
	dec Rstk
	str Rstk

	LDREG(Rtmp2, segs_dr_digit_0)

	CALL(drawbyte)
	inc Rstk
	CALL(drawbyte)
	inc Rstk
	CALL(drawbyte)
	inc Rstk

	RETURN

	.align 8

dokey:

	ADJUST(Rram, key)
	ldn Rram
	smi 'P'
	bnz 1f
	CLR(bellreg, ALO)
	CALL(txon)
	CALL(display)
	CALL(waitkey)
	CALL(txoff)
	RETURN
1:
	ldn Rram
	smi '*'
	bnz 1f
	CALL(txon)
	CALL(display)
	CALL(waitkeybeep)
	CALL(txoff)
	RETURN
1:
	ADJUST(Rram, lighttimer)
	ldi 0
	str Rram
	inc Rram
	ldi 1
	str Rram
	LIT(BIT_KEYLIGHT)
	LIT(BIT_LCDLIGHT)

	ADJUST(Rram, key)
	ldn Rram
	smi 10
	lbnf dodigit

	ldn Rram
	smi 'E'
	bnz 1f
	ADJUST(Rram, rptr)
	ldn Rram
	ani 1
	xri 1
	str Rram
	CALL(dorptr)
	CALL(display)
	RETURN
1:
	ldn Rram
	smi 'C'
	bnz 1f
	CALL(backspace)
	RETURN
1:
	ldn Rram
	smi '+'
	bnz 1f
	CALL(dovola), 1
	RETURN
1:
	ldn Rram
	smi '-'
	bnz 1f
	CALL(dovola), -1
	RETURN
1:
	ldn Rram
	smi 'S'
	bnz 1f
	CALL(synth), 1
	RETURN
1:
	ldn Rram
	smi 'R'
	bnz 1f
	CALL(synth), -1
	RETURN
1:
	ldn Rram
	smi 'B'
	bnz 1f
	FLIP(wdrreg, WDR)
	SET(audioreg, AUDIO)
	SET(hfreg, HF)
	LIT(BIT_SERV)
	CALL(display)
	CALL(waitkey)
	RETURN
1:
	ldn Rram
	smi '#'
	bnz 1f
	CALL(dopower)
	CALL(zerobuf)
	CALL(synth), 0
	RETURN
1:
	RETURN

dopower:
	ADJUST(Rptr, digidx)
	ldn Rptr
	smi 1
	bnz 1f
	ADJUST(Rptr, digbuf)

	ADJUST(Rram, txpower)
ldn Rptr
smi 4
lbz segtst
	ldn Rptr
	ani 3
	str Rram
1:
	ADJUST(Rram, txpower)
	ldn Rram
	ani 1
	lbz 1f
	CALL(marker_on), SEG_BAR_R
	lbr 2f
1:
	CALL(marker_off), SEG_BAR_R
2:
	ADJUST(Rram, txpower)
	ldn Rram
	ani 2
	lbz 1f
	CALL(marker_on), SEG_BAR_L
	lbr 2f
1:
	CALL(marker_off), SEG_BAR_L
2:
	RETURN

backspace:

	ADJUST(Rram, digidx)
	ldn Rram
	bnz 1f
	RETURN
1:
	smi 1
	ani 3
	str Rram
	adi LO(digbuf)
	plo Rptr
	ldi ' '
	str Rptr

	ldn Rram
	bnz 1f
	CALL(synth), 0
	RETURN
1:

	ADJUST(Rtmp2, segs_dr_digit_3)

	dec Rstk

	ADJUST(Rram, digbuf + 0)
	ldn Rram
	str Rstk
	CALL(drawchr)

	ADJUST(Rram, digbuf + 1)
	ldn Rram
	str Rstk
	CALL(drawchr)

	ADJUST(Rram, digbuf + 2)
	ldn Rram
	str Rstk
	CALL(drawchr)

	ADJUST(Rram, digbuf + 3)
	ldn Rram
	str Rstk
	CALL(drawchr)

	inc Rstk

	RETURN

dodigit:
	ADJUST(Rram, key)
	ldn Rram
	plo Rtmp

	ADJUST(Rram, digidx)
	ldn Rram
	ani 3
	adi 1
	str Rram
	adi LO(digbuf) - 1
	plo Rptr
	glo Rtmp
	str Rptr

	ldn Rram
	smi 4
	bnz 1f
	CALL(chanlookup)
	CALL(zerobuf)
	CALL(synth), 0
	RETURN
1:

	ADJUST(Rtmp2, segs_dr_digit_3)

	dec Rstk

	ADJUST(Rram, digbuf + 0)
	ldn Rram
	str Rstk
	CALL(drawchr)

	ADJUST(Rram, digbuf + 1)
	ldn Rram
	str Rstk
	CALL(drawchr)

	ADJUST(Rram, digbuf + 2)
	ldn Rram
	str Rstk
	CALL(drawchr)

	ADJUST(Rram, digbuf + 3)
	ldn Rram
	str Rstk
	CALL(drawchr)

	inc Rstk

	RETURN

chanlookup:

	FLIP(wdrreg, WDR)

	ADJUST(Rram, digbuf)
	ADJUST(Rptr, digbuf)
	lda Rram
	shl4
	sex Rram
	or
	str Rptr
	inc Rram
	lda Rram
	shl4
	or
	str Rram

	ldi 0
	plo Rtmp

	LDREG(Rtmp2, channels)
1:
	inc Rtmp2
	inc Rtmp2

	lda Rtmp2
	sex Rptr
	xor
	bnz 2f
	ldn Rtmp2
	sex Rram
	xor
	bz 3f
2:
	inc Rtmp2
	inc Rtmp
	glo Rtmp
	bnz 1b
	br 4f
3:
	ADJUST(Rram, channel)
	glo Rtmp
	str Rram
4:
	RETURN

zerobuf:
	ADJUST(Rram, digidx)
	ldi 0
	str Rram

	ADJUST(Rram, digbuf)
	ldi ' ' ; str Rram
	inc Rram; str Rram
	inc Rram; str Rram
	inc Rram; str Rram

	RETURN

	.align 8

waitkeybeep:
	ADJUST(Rram, audioreg)
	ADJUST(Rptr, pscreg)
	LDREG(Rtmp2, wdrreg)

	ldn Rram
	ani ~NMIC
	ani ~NPHI
	str Rram
1:
	ldn Rtmp2		# 2
	xri WDR			# 4
	str Rtmp2		# 6
	sex Rtmp2		# 8
	out REG			# 10
	dec Rtmp2		# 12 watchdog flipped

	ldn Rram		# 14
	xri NPHI		# 16
	str Rram		# 18
	sex Rram		# 20
	out REG			# 22
	dec Rram		# 24 NPHI flipped

	ldn Rptr		# 26
	ori PSC			# 28
	str Rptr		# 30
	sex Rptr		# 32
	out REG			# 34
	dec Rptr		# 36
	ani ~PSC		# 38
	str Rptr		# 40
	out REG			# 42
	dec Rptr		# 44 PSC pulsed

	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop # 74
	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop # 104
	nop ; nop ; nop ; nop ; nop ; nop ; nop ; nop             # 128
	ldi 0                                                     # 130

	bn3 1b			# 132

	/*
	 *  Loop for 1750 Hz with 3.6864 MHz pclk.
	 *  
	 * 2 loops form one cycle of 1750.
	 * 1750 Hz cycle is 0.000571429 sec.
	 * one loop takes half of that, 0.000285714 sec.
	 * one cpu cycle is 0.000002170 sec.
	 * Loop takes 132 cpu cycles.
	 */
	CLR(audioreg, NMIC | NPHI)

	CLR(bellreg, ALO)

	RETURN

waitkey:
	CLR(bellreg, ALO)
1:
	FLIP(wdrreg, WDR)
	PULSE(pscreg, PSC)
	bn3 1b

	RETURN

shutdown:

	SET(offreg, OFF1)
	CLR(wdrreg, WDR)
	br .

1:
	sex Rstk
	ret
int:
	dec Rstk
	sav
	lbr 1b

	.align 8

keypad:

	SET(bellreg, ALO)

	CUSEL(KEYPAD)		#	strobe the data into shifter

	PULSE(cureg, CLK)

	CUSEL(LCD1)

	;				# ignore darkness info

	ldi 0
	plo Rtmp

	PULSE(cureg, CLK); glo Rtmp ; shl ; plo Rtmp ; b1 1f; inc Rtmp ; 1:
	PULSE(cureg, CLK); glo Rtmp ; shl ; plo Rtmp ; b1 1f; inc Rtmp ; 1:
	PULSE(cureg, CLK); glo Rtmp ; shl ; plo Rtmp ; b1 1f; inc Rtmp ; 1:
	PULSE(cureg, CLK); glo Rtmp ; shl ; plo Rtmp ; b1 1f; inc Rtmp ; 1:
	PULSE(cureg, CLK); glo Rtmp ; shl ; plo Rtmp ; b1 1f; inc Rtmp ; 1:

	ADJUST(Rram, keycode)
	glo Rtmp
	str Rram

	glo Rtmp
	adi LO(keytbl)
	plo Rtbl

	ADJUST(Rram, key)
	ldn Rtbl
	str Rram

	RETURN


display:

	ADJUST(Rptr, segments)

	CUSEL(LCD2)

	CUSEL(LCD1)
	CALL(display_group)
	CALL(display_bit_zero)

	CUSEL(LCD2)
	CALL(display_group)
	CALL(display_bit_zero)

	CUSEL(LCD1)
	CALL(display_group)
	CALL(display_bit_one)

	CUSEL(LCD2)
	CALL(display_group)
	CALL(display_bit_one)

	CUSEL(LCD1)
	CALL(display_byte)

	CUSEL(LATCH)
	CUSEL(LCD1)

	RETURN

display_group:
	CALL(display_bit_zero)
	CALL(display_byte)
	CALL(display_byte)
	CALL(display_byte)
	CALL(display_byte)

	RETURN

display_byte:

	ldn Rptr; ani 0x01; smi 1; CALL(display_bit)
	ldn Rptr; ani 0x02; smi 1; CALL(display_bit)
	ldn Rptr; ani 0x04; smi 1; CALL(display_bit)
	ldn Rptr; ani 0x08; smi 1; CALL(display_bit)

	ldn Rptr; ani 0x10; smi 1; CALL(display_bit)
	ldn Rptr; ani 0x20; smi 1; CALL(display_bit)
	ldn Rptr; ani 0x40; smi 1; CALL(display_bit)
	ldn Rptr; ani 0x80; smi 1; CALL(display_bit)

	inc Rptr

	FLIP(wdrreg, WDR)
	RETURN

display_bit:
	lbnf display_bit_zero
	lbr  display_bit_one

display_bit_zero:
	CLR(cureg, DP)
	PULSE(cureg, CLK)
	CLR(cureg, DP)

	RETURN

display_bit_one:
	SET(cureg, DP)
	PULSE(cureg, CLK)
	CLR(cureg, DP)

	RETURN

drawbyte:
	FLIP(wdrreg, WDR)

	ldn Rbp
	ani 0xF
	dec Rstk
	str Rstk
	CALL(drawdig)
	inc Rstk
	glo Rtmp2
	smi 2 * 7
	plo Rtmp2
	ldn Rbp
	shr4
	dec Rstk
	str Rstk
	CALL(drawdig)
	inc Rstk
	glo Rtmp2
	smi 2 * 7
	plo Rtmp2

	RETURN

drawdig:
	ldn Rbp
	smi 10
	lsnf; adi 'A' - 10 - '0'
	adi 10 + '0'
	dec Rstk
	str Rstk
	CALL(drawchr)
	inc Rstk

	RETURN

drawfixed:

	dec Rstk
	lda Rarg
	str Rstk
	CALL(drawchr)
	inc Rstk
	RETURN

drawchr:

	ldn Rbp
	ani 0x7F
	plo Rtmp			# Rtmp -> segment bits
	ldi HI(font)		; ASSERT(LO(font) == 0)
	phi Rtmp

	dec Rstk

	lda Rtmp2; str Rstk; ldn Rtmp; ani 0x01; smi 1; CALL(segment_onoff)
	lda Rtmp2; str Rstk; ldn Rtmp; ani 0x02; smi 1; CALL(segment_onoff)
	lda Rtmp2; str Rstk; ldn Rtmp; ani 0x04; smi 1; CALL(segment_onoff)
	lda Rtmp2; str Rstk; ldn Rtmp; ani 0x08; smi 1; CALL(segment_onoff)

	lda Rtmp2; str Rstk; ldn Rtmp; ani 0x10; smi 1; CALL(segment_onoff)
	lda Rtmp2; str Rstk; ldn Rtmp; ani 0x20; smi 1; CALL(segment_onoff)
	lda Rtmp2; str Rstk; ldn Rtmp; ani 0x40; smi 1; CALL(segment_onoff)

	inc Rstk

	RETURN

marker_on:
	lda Rarg
	dec Rstk
	str Rstk
	CALL(segment_on)
	inc Rstk
	RETURN

marker_off:
	lda Rarg
	dec Rstk
	str Rstk
	CALL(segment_off)
	inc Rstk
	RETURN

segment_onoff:
	lbnf segment_off

segment_on:

	ldn Rbp
	ani 7				# bit-offset in byte
	adi LO(setbit)
	plo Rtbl

	ldn Rbp
	shr					# /= 2
	shr					# /= 4
	shr					# /= 8, byte-offset in segments
	ani 15
	adi LO(segments)
	plo Rram

	ldn Rtbl
	sex Rram
	or
	str Rram

	RETURN

segment_off:

	ldn Rbp
	ani 7
	adi LO(clrbit)
	plo Rtbl

	ldn Rbp
	shr
	shr
	shr					# bit-offset into byte
	ani 15
	adi LO(segments)
	plo Rram

	ldn Rtbl
	sex Rram
	and
	str Rram

	RETURN

segment_flip:

	ldn Rbp
	ani 7
	adi LO(setbit)
	plo Rtbl

	ldn Rbp
	shr
	shr
	shr					# bit-offset into byte
	ani 15
	adi LO(segments)
	plo Rram

	ldn Rtbl
	sex Rram
	xor
	str Rram

	RETURN

nextkey:
1:
	FLIP(wdrreg, WDR)
	PULSE(pscreg, PSC)

	b3 1b
	CALL(keypad)
	CALL(waitkey)
	CLR(bellreg, ALO)
	RETURN

segtst_one:
	FLIP(wdrreg, WDR)

	lda Rarg
	dec Rstk
	str Rstk

	LDREG(Rtmp2, segs_u_digit_2)
	CALL(drawbyte)

	CALL(segment_on)

	CALL(display)
	CALL(nextkey)

	CALL(segment_off)
	inc Rstk

	RETURN

segtst:
	CALL(waitkey)

	CALL(segtst_one), 0x63
	CALL(segtst_one), 0x6B
	CALL(segtst_one), 0x6F
	CALL(segtst_one), SEG_KEY
	CALL(segtst_one), SEG_T
	CALL(segtst_one), SEG_C
	CALL(segtst_one), SEG_COLON_L
	CALL(segtst_one), SEG_COLON_R
	CALL(segtst_one), SEG_BAR_L
	CALL(segtst_one), SEG_BAR_R
	CALL(segtst_one), SEG_S
	CALL(segtst_one), SEG_F
	CALL(segtst_one), SEG_D
	CALL(segtst_one), SEG_I
	CALL(segtst_one), SEG_LESS
	CALL(segtst_one), SEG_N

	RETURN

	.align 8

tables:

keytbl:
	.byte  3 , 2 , 1 ,'C', 6 , 5 , 4 ,'S'
	.byte  9 , 8 , 7 ,'R','#', 0 ,'*','E'
	.byte 'P','B','-','+','Z','Z','Z','Z'
	.byte 'Z','Z','Z','Z','Z','Z','Z','Z'

setbit:
	.byte 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80
clrbit:
	.byte 0xFE, 0xFD, 0xFB, 0xF7, 0xEF, 0xDF, 0xBF, 0x7F

#define X(seg) (seg)

/*	down left digit-area */

segs_dl_digit_1:	.byte X(56), X(57), X(58), X(59),	X(120), X(121), X(122)
segs_dl_digit_0:	.byte X(60), X(61), X(62), X(63),	X(124), X(125), X(126)


/*	down right digit-area */

segs_dr_digit_7:	.byte  X(0),  X(1),  X(2),  X(3),	 X(64),  X(65), X(66)
segs_dr_digit_6:	.byte  X(4),  X(5),  X(6),  X(7),	 X(68),  X(69), X(70)
segs_dr_digit_5:	.byte  X(8),  X(9), X(10), X(11),	 X(72),  X(73), X(74)
segs_dr_digit_4:	.byte X(12), X(13), X(14), X(15),	 X(76),  X(77), X(78)
segs_dr_digit_3:	.byte X(16), X(17), X(18), X(19),	 X(80),  X(81), X(82)
segs_dr_digit_2:	.byte X(20), X(21), X(22), X(23),	 X(84),  X(85), X(86)
segs_dr_digit_1:	.byte X(24), X(25), X(26), X(27),	 X(88),  X(89), X(90)
segs_dr_digit_0:	.byte X(28), X(29), X(30), X(31),	 X(92),  X(93), X(94)

/*	upper digit-area */

segs_u_digit_5:		.byte X(32), X(33), X(34), X(35),	 X(96),  X(97),  X(98)
segs_u_digit_4:		.byte X(36), X(37), X(38), X(39),	X(100), X(101), X(102)
segs_u_digit_3:		.byte X(40), X(41), X(42), X(43),	X(104), X(105), X(106)
segs_u_digit_2:		.byte X(44), X(45), X(46), X(47),	X(108), X(109), X(110)
segs_u_digit_1:		.byte X(48), X(49), X(50), X(51),	X(112), X(113), X(114)
segs_u_digit_0:		.byte X(52), X(53), X(54), X(55),	X(116), X(117), X(118)

#undef X

#if 0
	   -     4
	  | |  0   3
	   -     5
	  | |  1   2
	   -     6
#endif

	.ascii VERSION

	.align 8

font:

	.byte	0x5f	# 0 	0 1 2 3   4 - 6
	.byte	0x0c	# 1 	- - 2 3   - - -
	.byte	0x7a	# 2 	- 1 - 3   4 5 6
	.byte	0x7c	# 3 	- - 2 3   4 5 6
	.byte	0x2d	# 4 	0 - 2 3   - 5 -
	.byte	0x75	# 5 	0 - 2 -   4 5 6
	.byte	0x77	# 6 	0 1 2 -   4 5 6
	.byte	0x1c	# 7 	- - 2 3   4 - -
	.byte	0x7f	# 8 	0 1 2 3   4 5 6
	.byte	0x7d	# 9 	0 - 2 3   4 5 6
	.byte	0x3f	# A 	0 1 2 3   4 5 -
	.byte	0x67	# b 	0 1 2 -   - 5 6
	.byte	0x53	# C 	0 1 - -   4 - 6
	.byte	0x6e	# d 	- 1 2 3   - 5 6
	.byte	0x73	# E 	0 1 - -   4 5 6
	.byte	0x33	# F 	0 1 - -   4 5 -

	.byte	0x57	# G 	0 1 2 -   4 - 6

	.org font + ' '

	.byte	0x00	#   	- - - -   - - -
	.byte	0x0c	# ! 	- - 2 3   - - -
	.byte	0x09	# " 	0 - - 3   - - -
	.byte	0x66	# # 	- 1 2 -   - 5 6
	.byte	0x25	# $ 	0 - 2 -   - 5 -
	.byte	0x05	# % 	0 - 2 -   - - -
	.byte	0x6a	# & 	- 1 - 3   - 5 6
	.byte	0x08	# ' 	- - - 3   - - -
	.byte	0x0c	# ( 	- - 2 3   - - -
	.byte	0x03	# ) 	0 1 - -   - - -
	.byte	0x70	# * 	- - - -   4 5 6
	.byte	0x23	# + 	0 1 - -   - 5 -
	.byte	0x02	# , 	- 1 - -   - - -
	.byte	0x20	# - 	- - - -   - 5 -
	.byte	0x02	# . 	- 1 - -   - - -
	.byte	0x2a	# / 	- 1 - 3   - 5 -
	.byte	0x5f	# 0 	0 1 2 3   4 - 6
	.byte	0x0c	# 1 	- - 2 3   - - -
	.byte	0x7a	# 2 	- 1 - 3   4 5 6
	.byte	0x7c	# 3 	- - 2 3   4 5 6
	.byte	0x2d	# 4 	0 - 2 3   - 5 -
	.byte	0x75	# 5 	0 - 2 -   4 5 6
	.byte	0x77	# 6 	0 1 2 -   4 5 6
	.byte	0x1c	# 7 	- - 2 3   4 - -
	.byte	0x7f	# 8 	0 1 2 3   4 5 6
	.byte	0x7d	# 9 	0 - 2 3   4 5 6
	.byte	0x50	# : 	- - - -   4 - 6
	.byte	0x48	# ; 	- - - 3   - - 6
	.byte	0x2c	# < 	- - 2 3   - 5 -
	.byte	0x60	# = 	- - - -   - 5 6
	.byte	0x23	# > 	0 1 - -   - 5 -
	.byte	0x3a	# ? 	- 1 - 3   4 5 -
	.byte	0x7e	# @ 	- 1 2 3   4 5 6
	.byte	0x3f	# A 	0 1 2 3   4 5 -
	.byte	0x67	# b 	0 1 2 -   - 5 6
	.byte	0x53	# C 	0 1 - -   4 - 6
	.byte	0x6e	# d 	- 1 2 3   - 5 6
	.byte	0x73	# E 	0 1 - -   4 5 6
	.byte	0x33	# F 	0 1 - -   4 5 -
	.byte	0x57	# G 	0 1 2 -   4 - 6
	.byte	0x2f	# H		0 1 2 3   - 5 -
	.byte	0x0c	# I 	- - 2 3   - - -
	.byte	0x4e	# J 	- 1 2 3   - - 6
	.byte	0x2f	# K 	- 1 2 3   - - 6
	.byte	0x43	# L		0 1 - -   - - 6
	.byte	0x1f	# M		0 1 2 3   4 - -
	.byte	0x26	# N		- 1 2 -   - 5 -
	.byte	0x5f	# O 	0 1 2 3   4 - 6
	.byte	0x3b	# P 	0 1 - 3   4 5 -
	.byte	0x3d	# Q 	0 - 2 3   4 5 -
	.byte	0x1b	# R		0 1 - 3   4 - -
	.byte	0x75	# S 	0 - 2 -   4 5 6
	.byte	0x13	# T		0 1 - -   4 - -
	.byte	0x4f	# U 	0 1 2 3   - - 6
	.byte	0x4f	# V 	0 1 2 3   - - 6
	.byte	0x4f	# W 	0 1 2 3   - - 6
	.byte	0x70	# X		- - - -   4 5 6
	.byte	0x6d	# Y 	0 - 2 3   - 5 6
	.byte	0x7a	# Z 	- 1 - 3   4 5 6
	.byte	0x53	# [ 	0 1 - -   4 - 6
	.byte	0x25	# \ 	0 - 2 -   - 5 -
	.byte	0x5c	# ] 	- - 2 3   4 - 6
	.byte	0x10	# ^ 	- - - -   4 - -
	.byte	0x40	# _ 	- - - -   - - 6
	.byte	0x01	# ` 	0 - - -   - - -
	.byte	0x26	# a 	- 1 2 -   - 5 -
	.byte	0x67	# b 	0 1 2 -   - 5 6
	.byte	0x62	# c 	- 1 - -   - 5 6
	.byte	0x6e	# d 	- 1 2 3   - 5 6
	.byte	0x62	# e 	- 1 - -   - 5 6
	.byte	0x33	# f 	0 1 - -   4 5 -
	.byte	0x7d	# g 	0 - 2 3   4 5 6
	.byte	0x27	# h		0 1 2 -   - 5 -
	.byte	0x04	# i 	- - 2 -   - - -
	.byte	0x44	# j 	- - 2 -   - - 6
	.byte	0x27	# k 
	.byte	0x42	# l		- 1 - -   - - 6
	.byte	0x26	# m		- 1 2 -   - 5 -
	.byte	0x26	# n		- 1 2 -   - 5 -
	.byte	0x66	# o 	- 1 2 -   - 5 6
	.byte	0x3b	# p 	0 1 - 3   4 5 -
	.byte	0x3d	# q 	0 - 2 3   4 5 -
	.byte	0x22	# r		- 1 - -   - 5 -
	.byte	0x75	# s 	0 - 2 -   4 5 6
	.byte	0x63	# t		0 1 - -   - 5 6
	.byte	0x46	# u 	- 1 2 -   - - 6
	.byte	0x46	# v 	- 1 2 -   - - 6
	.byte	0x46	# w		- 1 2 -   - - 6
	.byte	0x06	# x		- 1 2 -   - - -
	.byte	0x2d	# y 	0 - 2 3   - 5 -
	.byte	0x60	# z 	- - - -   - 5 6
	.byte	0x62	# { 	- 1 - -   - 5 6
	.byte	0x02	# | 	- 1 - -   - - -
	.byte	0x64	# } 	- - 2 -   - 5 6
	.byte	0x10	# ~ 	- - - -   4 - -
	.byte	0x00	# ^? 	- 1 - 3   4 5 6

	fontsize = . - font

	ASSERT(fontsize == 128)

	.align 8

channels:

#include "channels"

